<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ page import="dynclass.BeanCreator,java.util.ArrayList" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Map" %>
<%!
    // sample employee data
    private static final String[][] EMP_DATA = {
        { "Katy Smith", "04454", "Software Engineer", "ks@company.co" },
        { "John Lewis", "94524", "Sales Representative", "jl@company.co" },
        { "Mary Watson", "85892", "VP of Engineering", "mw@company.co" },
        { "Thomas Dooley", "85893", "VP of Sales", "td@company.co" }
    };
    private static final Class beanClass = 
        BeanCreator.createClassForProperties(new String[] { 
            "name", 
            "employeeNumber",
            "title",
            "email address", // <- property name contains a space!
        });
%>
<%
    // This would really take place in a tag or action class.

    // Create a list to hold the employee beans.
    ArrayList al = new ArrayList();

    for (int i=0; i < EMP_DATA.length; i++) {
       
        // Create empData map from canned data.  Imagine db access here...
        Map empData = new HashMap();
        empData.put("name", EMP_DATA[i][0]);
        empData.put("employeeNumber", EMP_DATA[i][1]);
        empData.put("title", EMP_DATA[i][2]);
        empData.put("email address", EMP_DATA[i][3]);

        // Now convert empData map to a bean.
        Object bean = BeanCreator.createBean(beanClass, empData);

        // Add bean to list for display.
        al.add(bean);
    }

    // Add list to pageContext.
    pageContext.setAttribute("employeeList", al);
%>
<html>
  <head><title>BeanCreator Struts example</title></head>
<body bgcolor="#FFFFFF">

<p>The data in the following table was taken from JavaBeans created by
the 
<a href="http://dynclass.sourceforge.net/api/dynclass/BeanCreator.html">BeanCreator</a> 
class.  The source data is embedded in this JSP, but could come from anywhere.
</p>

<table>
    <tr>
      <th>Name</th>
      <th>Employee Number</th>
      <th>Title</th>
      <th>Email</th>
    </tr>
  <logic:iterate name='employeeList' id='employeeBean'>
    <tr>
      <td><bean:write name='employeeBean' property='name'/></td>
      <td><bean:write name='employeeBean' property='employeeNumber'/></td>
      <td><bean:write name='employeeBean' property='title'/></td>
      <td><bean:write name='employeeBean' property='email address'/></td>
    </tr>
  </logic:iterate>
</table>

</body>
</html>

