package dynclass;

import junit.framework.TestCase;

public class PropertyMethodNameTxTest extends TestCase {

    private static final String[][] PROP_METHOD = {
        { "userName", "UserName" },
        { "URL", "URL" },
        { "Password", "$Password" },
        { "", "$" },
        { "A property", "$A$32$property" },
        { "$", "$$" + Integer.toString('$') + "$" },
        { "$a", "$$" + Integer.toString('$') + "$a" },
    };

    public PropertyMethodNameTxTest(String name) {
        
        super(name);
    }

    public void testEncoding() {

        for (int i=0; i < PROP_METHOD.length; i++) {
            String[] data = PROP_METHOD[i];
            assertEquals("invalid encoding of " + data[0],
                         data[1], 
                         PropertyMethodNameTx.encodeProperty(data[0]));
        }
    }

    public void testDecoding() {

        for (int i=0; i < PROP_METHOD.length; i++) {
            String[] data = PROP_METHOD[i];
            assertEquals("invalid decoding of " + data[1],
                         data[0], 
                         PropertyMethodNameTx.decodeProperty(data[1], 0));
            assertEquals("invalid decoding of " + data[1],
                         data[0], 
                         PropertyMethodNameTx.decodeProperty("get" + data[1], 3));
        }
    }
}
